﻿/**
 * @author dochmann
 */

import mx.utils.Delegate;
import mx.events.EventDispatcher;
import de.davidochmann.utilities.dogesture.register.events.RegisterEvent;

class de.davidochmann.utilities.dogesture.register.Register extends EventDispatcher 
{
	private static var mInstance:Register;
	private var mSurface:MovieClip;
	
	
	
	private function Register(pSurface:MovieClip)
	{
		EventDispatcher.initialize(this);
		setSurface(pSurface);
	}

	public static function getInstance(pSurface:MovieClip):Register
	{
		if(! mInstance) mInstance = new Register(pSurface);
		return mInstance;
	}



	/*
	 * PUBLIC FUNCTIONS
	 */
	
	public function start():Void
	{
		mSurface.onMouseMove  = Delegate.create(this, surfaceMouseMoveHandler);
		mSurface.onMouseDown  = Delegate.create(this, surfaceMouseDownHandler);
		mSurface.onMouseUp    = Delegate.create(this, surfaceMouseUpHandler);
		mSurface.onEnterFrame = Delegate.create(this, surfaceEnterFrameHandler);
	}
	
	public function stop():Void
	{
		mSurface.onMouseMove  = null;
		mSurface.onMouseDown  = null;
		mSurface.onMouseUp    = null;
		mSurface.onEnterFrame = null;		
	}



	/*
	 * GETTER FUNCTIONS
	 */
	
	public function getSurface():MovieClip
	{
		return mSurface;
	}



	/*
	 * SETTER FUNCTIONS
	 */

	public function setSurface(pSurface:MovieClip):Void
	{
		mSurface = pSurface;
	}



	/*
	 * PRIVATE FUNCTIONS
	 */

	private function surfaceMouseMoveHandler():Void
	{
		dispatchEvent(new RegisterEvent(RegisterEvent.MOUSE_GESTURE_MOVE, this));
	}
	
	private function surfaceMouseDownHandler():Void
	{
		dispatchEvent(new RegisterEvent(RegisterEvent.MOUSE_GESTURE_DOWN, this));
	}
	
	private function surfaceMouseUpHandler():Void
	{
		dispatchEvent(new RegisterEvent(RegisterEvent.MOUSE_GESTURE_UP, this));
	}

	private function surfaceEnterFrameHandler():Void
	{
		dispatchEvent(new RegisterEvent(RegisterEvent.MOUSE_GESTURE_ENTER_FRAME, this));
	}


	
	/*
	 * EVENT DISPATCHER FUNCTIONS
	 */

	public function addEventListener(type:String, listener:Object):Void{};
	
	public function removeEventListener(type:String, listener:Object):Void{};
	
	private function dispatchEvent(event:Object):Void{};
}
