﻿/**
 * @author dochmann
 */
 
import de.davidochmann.utilities.dogesture.move.Move;

class de.davidochmann.utilities.dogesture.stack.Stack 
{
	private var mList:Array;
	private var mActive:Move;
	private var mIndex:Number;
	private var mComplete:Boolean;
	
	
	
	public function Stack()
	{
		initList();
		initIndex();
		initComplete();
	}
	

	
	/*
	 * PUBLIC FUNCTIONS
	 */

	public function list():Array
	{
		return mList;
	}

	public function active():Move
	{
		return mActive;
	}

	public function complete():Boolean
	{
		return mComplete;
	}

	public function index():Number
	{
		return mIndex;
	}

	public function add(pMove:Move):Void
	{
		mList.push(pMove);
		initActive();
	}

	public function reset():Void
	{
		initIndex();
		initActive();
		initComplete();
	}
		
	public function next():Void
	{
		if(mIndex + 1 == mList.length)
		{
			mIndex ++;
			mComplete = true;
			return;
		}
		
			
		mIndex ++;
		mActive = mList[mIndex];
	}


	
	/*
	 * PRIVATE FUNCTIONS
	 */
	
	public function initList():Void
	{
		mList = new Array();
	}
	
	public function initIndex():Void
	{
		mIndex = 0;
	}
	
	private function initActive():Void
	{
		mActive = Move(mList[mIndex]);
	}

	public function initComplete():Void
	{
		mComplete = false;
	}
}